<?php
namespace Fiscal\Repositories;

class Rateionf extends \Doctrine\ORM\EntityRepository
{

    /**
     *
     *
     * @param $cdfilial
     * @param $nrlanctonf
     * @param $cdfilirece
     * @throws \Exception
     */
    public function insereRateioEntrada($cdfilial, $nrlanctonf, $cdfilirece)
    {
        $sql = "INSERT INTO RATEIONF(CDFILIAL, NRLANCTONF, NRSEQITPROD, CDFILICCUST, VRRATENF,   CDCENTCUSNF, VRPERRAT)
            (
                SELECT I.CDFILIAL,
                  I.NRLANCTONF,
                  I.NRSEQITPROD,
                  N.CDFILIRECE,
                  I.VRCONTITEM,
                  NVL(NVL(NVL(PF.CDCCUSTENTRF,P.CDCCUSTENTR),F.CDCENTCUST),E.CDCENTCUST) CDCENTCUST,
                  100 AS VRPERRAT
                FROM NOTAFISCAL N, ITEMPRODUTO I, PRODFILI PF,
                  PRODUTO P, EMPRESA E, FILIAL F
                WHERE N.CDFILIAL        = '$cdfilial'
                    AND N.NRLANCTONF    = '$nrlanctonf'
                    AND I.CDFILIAL      = '$cdfilial'
                    AND I.NRLANCTONF    = '$nrlanctonf'
                    AND I.CDPRODUTO     = PF.CDPRODUTO(+)
                    AND PF.CDFILIAL(+)  = NVL(I.CDFILIMOVI,'$cdfilirece')
                    AND I.CDPRODUTO     = P.CDPRODUTO
                    AND N.CDEMPRESA     = E.CDEMPRESA
                    AND N.CDFILIRECE    = F.CDFILIAL
                    AND NVL(NVL(NVL(PF.CDCCUSTENTRF,P.CDCCUSTENTR), F.CDCENTCUST),E.CDCENTCUST) IS NOT NULL
            )";

        try {
            $this->getEntityManager()->getConnection()->exec($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    /**
     *
     * @param $cdfilial
     * @param $nrlanctonf
     */
    public function insereRateioSaida($cdfilial, $nrlanctonf)
    {
        $sql = "INSERT INTO RATEIONF
                  (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDFILICCUST, VRRATENF, CDCENTCUSNF, VRPERRAT)
                  (SELECT I.CDFILIAL,
                    I.NRLANCTONF,
                    I.NRSEQITPROD,
                    N.CDFILIEMIT,
                    I.VRCONTITEM,
                    NVL(NVL(NVL(PF.CDCCUSTSAIDF,P.CDCCUSTSAID),F.CDCENTCUST),E.CDCENTCUST) CDCENTCUST,
                    100 AS VRPERRAT
                  FROM NOTAFISCAL N, ITEMPRODUTO I, PRODFILI PF, PRODUTO P, EMPRESA E, FILIAL F
                  WHERE N.CDFILIAL       = '$cdfilial'
                    AND N.NRLANCTONF     = '$nrlanctonf'
                    AND I.CDFILIAL       = '$cdfilial'
                    AND I.NRLANCTONF     = '$nrlanctonf'
                    AND I.CDPRODUTO      = PF.CDPRODUTO
                    AND PF.CDFILIAL      = N.CDFILIEMIT
                    AND I.CDPRODUTO      = P.CDPRODUTO
                    AND N.CDEMPRESA      = E.CDEMPRESA
                    AND N.CDFILIEMIT     = F.CDFILIAL
                    AND NVL(NVL(NVL(PF.CDCCUSTSAIDF,P.CDCCUSTSAID),F.CDCENTCUST),E.CDCENTCUST) IS NOT NULL)
                ";

        try {
            $this->getEntityManager()->getConnection()->exec($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function rateioProduto($cdfilial, $nrlanctonf, $nrseqitprod){
        $sql = <<<SQL
        SELECT R.CDFILIAL, R.NRLANCTONF, R.NRSEQITPROD, R.CDFILICCUST, F.NMFILIAL,
               R.CDCENTCUSNF, C.NMCENTCUST, ROUND(R.VRRATENF, 2) AS VRRATENF, DSRATEIO
        FROM RATEIONF R, FILIAL F, CENTCUST C
        WHERE (R.CDFILIAL    = :P_CDFILIAL)    AND
              (R.NRLANCTONF  = :P_NRLANCTONF)  AND
              (R.NRSEQITPROD = :P_NRSEQITPROD) AND
              (R.CDFILICCUST = F.CDFILIAL)     AND
              (R.CDCENTCUSNF = C.CDCENTCUST)
        ORDER BY R.CDFILICCUST, R.CDCENTCUSNF
SQL;

        $params = array(
            "P_CDFILIAL" => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_NRSEQITPROD" => $nrseqitprod
        );

        try{
            return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
}